c
c     program sorter will read structures from unit 10 (fort.10)
c     as generated by promet version 6.0
c     or by program minopec
c     and produce sorted structures on unit 11 (fort.11)
c     of course fort.11 can be re-input by renaming it fort.10
c
c     sorting is by discarding duplicate structures over
c     Niggli reduced cells, and by discarding structures
c     whose energy is below an input threshold
c     
c     january 1999
c
c     note: promet 6 already has sorter as a subroutine
c     only over Niggli reduced cells (no energy threshold)
c
      COMMON /merge/ FAM(5000,8),PORIG(5000,6)
      COMMON/MINI/KI(12)
      DIMENSION PAR(6),PARN(6),SMAT(16,9),TV(16,3),ifound(5000)
      dimension bestp(6)
      open (unit=10,file='fort.10')
      open (unit=11,file='fort.11')
C     ISTM IS MAX NUMBER OF STRUCTURES
      ISTM=5000
      write(6,602)
 602  format(2x,'enter a threshold energy <0, zero will take all')
      read(5,*) ethr
C     ZERO STRUCTURE COUNTERS AND LINE COUNTER
      rewind 10
      ISTR=0
      NSTR=0
      LINE=0
      isc1=0
      ISC2=0
      inig=1             
      ihg=1                
      besten=0.0
C     START READING STRUCTURE DATA
 991  CONTINUE   
      READ(10,171,END=999) nustr,vc,en          
 171  format(14x,i5,2x,2f10.2)
      LINE=LINE+1
      read(10,178) ki,dmom
 178  format(12i1,f10.3)
      line=line+1
      read (10,179) idum                    
 179  format(4i5,2f10.2)
      line=line+1
      READ(10,177) a,b,c,alf,bet,gam
 177  FORMAT(6f10.4)
      LINE=LINE+1
 2    FORMAT(2i5,60x,12i1)
      NSTR=NSTR+1
C     NIGGLI CELL REDUCTION
      PAR(1)=A
      PAR(2)=B
      PAR(3)=C
      PAR(4)=ALF
      PAR(5)=BET
      PAR(6)=GAM
c     save best structure
      if(en.gt.besten) go to 181
      besten=en
      do 182 i=1,6
 182  bestp(i)=par(i)
 181  continue
      CALL NIGGLI (PAR,PARN)
      A=PARN(1)
      B=PARN(2)
      C=PARN(3) 
      ALF=PARN(4) 
      BET=PARN(5) 
      GAM=PARN(6)  
C     READ AND SKIP ATOMIC COORDINATES
      natomx=0
 4    continue           
      READ(10,5) idummy
 5    FORMAT(I5)
      LINE=LINE+1
      natomx=natomx+1
      if(idummy.ne.999) go to 4
      natomx=natomx-1
      do 992 i=1,16      
      read(10,173) (smat(i,l),l=1,9)
 173  format(9f5.1)
      if(smat(i,1).gt.1.) go to 993
      line=line+1
      read(10,173) (tv(i,k),k=1,3)
      line=line+1
 992  continue
 993  continue
      do 994 i=1,4
 994  read(10,995) idum
 995  format(i1)
      if(en.lt.ethr) go to 251
      isc1=isc1+1
      go to 991
C     CHECK IF STRUCTURE IS A NEW ONE
 251  CONTINUE      
      TOLANG=2.0
C     SKIP CHECK IF THIS IS THE FIRST STRUCTURE
      IF(ISTR.EQ.0) GO TO 14
      DO 122 K=1,ISTR
      tole=0.015*(en+fam(k,8))*0.5
      tole=abs(tole)
      TOLA=0.035*(A+FAM(K,1))*0.5
      TOLB=0.035*(B+FAM(K,2))*0.5
      TOLC=0.035*(C+FAM(K,3))*0.5
      TOLV=0.070*(VC+FAM(K,7))*0.5
      IS=0
      IF(ABS(A-FAM(K,1)).GT.TOLA) IS=1
      IF(ABS(B-FAM(K,2)).GT.TOLB) IS=1
      IF(ABS(C-FAM(K,3)).GT.TOLC) IS=1
      ABE=ABS(ALF-FAM(K,4))
      ABF=ABS(180.-ALF-FAM(K,4))
      IF(ABE.GT.TOLANG.AND.ABF.GT.TOLANG) IS=1
      BBE=ABS(BET-FAM(K,5))
      BBF=ABS(180.-BET-FAM(K,5))
      IF(BBE.GT.TOLANG.AND.BBF.GT.TOLANG) IS=1
      GBE=ABS(GAM-FAM(K,6))
      GBF=ABS(180.-GAM-FAM(K,6))
      IF(GBE.GT.TOLANG.AND.GBF.GT.TOLANG) IS=1
      IF(ABS(VC-FAM(K,7)).GT.TOLV) IS=1
      IF(ABS(EN-FAM(K,8)).GT.TOLE) IS=1
      IF(IS.NE.0) GO TO 122
C     IS=0, THE STRUCTURE IS NOT NEW
      ISC2=ISC2+1
      GO TO 991
 122  CONTINUE
  14  ISTR=ISTR+1
      if(istr.gt.istm) go to 999
      CALL STO(ISTR,A,B,C,ALF,BET,GAM,VC,EN,PAR)
      GO TO 991
c     end first reading of tape 10
 999  CONTINUE
      WRITE(6,12) NSTR,ISTR,isc1,ISC2
 12   FORMAT(I6,1X,'STRUCTURES READ',I6,1X,'ACCEPTED',
     1 /2x,i6,'discarded as below threshold',
     2 /2x,i6,'discarded as duplicate'/)
c     stop if nothing found
      if(nstr.eq.0) stop
      write(6,183) besten,(bestp(k),k=1,6)
 183  format(1x,'Best energy',f10.2,2x,'cell',3f10.3,3f10.2)
      rewind 10
      noptim=0
      do 1778 i=1,istr
 1778 ifound(i)=0
c     prepare new tape (unit 11) with sorted structures
 71   continue       
      READ(10,171,END=88) nustr,vc,en
      read(10,178) ki,dmom
      read (10,179) idum
      READ(10,177) a,b,c,al,be,ga
      ISORT=0
      DO 13 I=1,istr
      if(abs(a-porig(i,1)).gt.0.0) go to 13
      if(abs(b-porig(i,2)).gt.0.0) go to 13
      if(abs(c-porig(i,3)).gt.0.0) go to 13
      if(abs(vc-fam(i,7)).gt.0.0) go to 13
      if(abs(en-fam(i,8)).gt.0.0) go to 13
      if(ifound(i).eq.0) ISORT=1
      go to 21
 13   continue
      go to 22
 15   FORMAT(1X,A5,1X,6F7.2,F11.2,F8.2)
 21   if(isort.eq.0) go to 22
      noptim=noptim+1
      ifound(i)=1
      WRITE(11,66) noptim,vc,en
 66   format(2x,'structure n.',i5,2x,2f10.2)
      WRITE(11,67) ki,dmom
 67   FORMAT(12i1,f10.3)                           
      WRITE(11,68) 1010,31,0,10.,-10.,0,0,0,-5.
 68   FORMAT(3I5,2F10.1,3I5,10X,F7.1)
      WRITE(11,69) A,B,C,AL,BE,GA
 69   FORMAT(6F10.4)
 22   continue
      do 1772 i=1,natomx
      read(10,84) nat,x,y,z,pes,isp,q,ra
 23   format(9f5.2)
 84   format(i5,3f10.4,f10.2,4x,i5,f10.3,f5.2)
      if(isort.ne.0) WRITE(11,84) i,X,Y,Z,PES,ISP,Q,ra
 1772 continue
      read(10,995) idum
      npen=0
      do 990 i=1,16
      read(10,173) (smat(i,l),l=1,9)
      if(smat(i,1).gt.1.0) go to 1111
      npen=npen+1
      read(10,173) (tv(i,k),k=1,3)
 990  continue
 1111 continue
      do 899 i=1,4
 899  read(10,995) idum
      if(isort.eq.0) go to 71
      WRITE(11,84) 999
      do 1775 i=1,npen
      WRITE(11,23) (smat(i,k),k=1,9)
      WRITE(11,23) (tv(i,k),k=1,3)
 1775 continue
      write(11,23) 99.
      WRITE(11,26) 98,1,3,99,98
 26   FORMAT(I5/2I3/I3/I4)
      go to 71
c     file 11 is prepared for input to the final optimization module
 88   continue
      stop
      END     
      SUBROUTINE STO(ISTR,A,B,C,ALF,BET,GAM,VC,EN,PAR)
C     CHARACTER*2 SYM,SYMX
      COMMON /merge/ FAM(5000,8),PORIG(5000,6)
      DIMENSION PAR(6)
      FAM(ISTR,1)=A
      FAM(ISTR,2)=B
      FAM(ISTR,3)=C
      FAM(ISTR,4)=ALF
      FAM(ISTR,5)=BET
      FAM(ISTR,6)=GAM
      FAM(ISTR,7)=VC
      FAM(ISTR,8)=EN
      DO 15 I=1,6
 15   PORIG(ISTR,I)=PAR(I)
      write(6,11) (par(i),i=1,6),vc,en
      write(6,12) (fam(istr,i),i=1,6) 
 11   format(2x,'new cell',3f7.2,3f8.1,2x,f8.1,f8.2)
 12   format(2x,'reduced',3f7.2,3f8.1)
      RETURN
      END
      SUBROUTINE NIGGLI(PAR,PARN)
C-----Crivy & Gruber algorithm (Acta Cryst.(1976).A32,297).
      DIMENSION PAR(6),PARN(6)
      DIMENSION MT(3,3),AMT(3,3),CN(3),AN(3),ANIG(6) 
      DIMENSION C1(3),A1(3),C2(3),SC2(3),A2(3),SA2(3),CS(3),SN(3),T(3,3)
      RD=57.295779513
      DO 1 I=1,3
      C2(I)=PAR(I)
      A2(I)=PAR(I+3)/RD
      CS(I)=COS(A2(I))
      IF(ABS(CS(I)).LT.1E-6)CS(I)=0.
      SN(I)=SIN(A2(I))
      C1(I)=C2(I)
1     A1(I)=A2(I)
      A=C1(1)**2
      B=C1(2)**2
      C=C1(3)**2
      X=2*C1(2)*C1(3)*CS(1)
      E=2*C1(1)*C1(3)*CS(2)
      Z=2*C1(1)*C1(2)*CS(3)
      DO 2 I=1,3
      DO 2 J=1,3
      AMT(I,J)=0.0
      T(I,J)=0.0
      IF(I.EQ.J)  T(I,J)=1.
2     IF(I.EQ.J)AMT(I,J)=1.
      NN=0
3     CONTINUE
      IF(ABS(X).LT.1E-5)X=0.0
      IF(ABS(E).LT.1E-5)E=0.0
      IF(ABS(Z).LT.1E-5)Z=0.0
      IF(ABS(A-B).LT.1E-5)B=A
      IF(ABS(A-C).LT.1E-5)C=A
      IF(ABS(B-C).LT.1E-5)C=B
      IF(ABS(ABS(X)-ABS(A)).LT.1E-5)X=ISG(X)*A
      IF(ABS(ABS(E)-ABS(A)).LT.1E-5)E=ISG(E)*A
      IF(ABS(ABS(Z)-ABS(A)).LT.1E-5)Z=ISG(Z)*A
      IF(ABS(ABS(X)-ABS(B)).LT.1E-5)X=ISG(X)*B
      IF(ABS(ABS(E)-ABS(B)).LT.1E-5)E=ISG(E)*B
      IF(ABS(ABS(Z)-ABS(B)).LT.1E-5)Z=ISG(Z)*B
      IF(ABS(ABS(X)-ABS(C)).LT.1E-5)X=ISG(X)*C
      IF(ABS(ABS(E)-ABS(C)).LT.1E-5)E=ISG(E)*C
      IF(ABS(ABS(Z)-ABS(C)).LT.1E-5)Z=ISG(Z)*C
      NN=NN+1
      IF(NN.GT.1000) RETURN
      IF(A.GT.B.OR.(A.EQ.B.AND.ABS(X).GT.ABS(E)))GO TO 4
      GO TO 6
4     DP=A
      A=B
      B=DP
      DP=X
      X=E
      E=DP
      DO 5 I=1,3
      DO 5 J=1,3
5     MT(I,J)=0
      MT(1,2)=1
      MT(2,1)=1
      MT(3,3)=1
      CALL MTP3(MT,AMT)
6     CONTINUE
      IF(B.GT.C.OR.(B.EQ.C.AND.ABS(E).GT.ABS(Z)))GO TO 7
      GO TO 9
7     DP=B
      B=C
      C=DP
      DP=E
      E=Z
      Z=DP
      DO 8 I=1,3
      DO 8 J=1,3
8     MT(I,J)=0
      MT(1,1)=1
      MT(2,3)=1
      MT(3,2)=1
      CALL MTP3(MT,AMT)
      GO TO 3
9     DO 10 I=1,3
      DO 10 J=1,3
10    MT(I,J)=0.0
      DO 11 I=1,3
11    MT(I,I)=1
      Y=X*E*Z
      IF(Y.LE.0.0) GO TO 33
      MT(1,1)=ISG(Y)*ISG(X)
      MT(2,2)=ISG(Y)*ISG(E)
      MT(3,3)=ISG(Y)*ISG(Z)
      CALL MTP3(MT,AMT)
      X=ABS(X)
      E=ABS(E)
      Z=ABS(Z)
      GO TO 12
33    IF(Y.EQ.0.0) GO TO 34
      MT(1,1)=ISG(Y)*ISG(X)
      MT(2,2)=ISG(Y)*ISG(E)
      MT(3,3)=ISG(Y)*ISG(Z)
      CALL MTP3(MT,AMT)
      X=-1.0*ABS(X)
      E=-1.0*ABS(E)
      Z=-1.0*ABS(Z)
      GO TO 12
34    CALL MTP3(MT,AMT)
12    IF(ABS(X).GT.B.OR.(X.EQ.B.AND.(2.*E).LT.Z).OR.
     1 (X.EQ.(-B).AND.Z.LT.0.0)) GO TO 16
      GO TO 18
16    DO 17 I=1,3
      DO 17 J=1,3
      MT(I,J)=0
17    IF(I.EQ.J)MT(I,J)=1
      MT(3,2)=-(ISG(X)*ISG(E)*ISG(Z))
      IF((X*E*Z).EQ.0.0)MT(3,2)=-1
      IF(X.EQ.0.0.AND.E.EQ.0.0.AND.Z.NE.0.0)MT(3,2)=-ISG(Z)
      IF(X.EQ.0.0.AND.E.NE.0.0.AND.Z.EQ.0.0)MT(3,2)=-ISG(E)
      IF(X.NE.0.0.AND.E.EQ.0.0.AND.Z.EQ.0.0)MT(3,2)=-ISG(X)
      CALL MTP3(MT,AMT)
      C=B+C-X*ISG(X)
      E=E-Z*ISG(X)
      X=X-2.*B*ISG(X)
      GO TO 3
18    IF(ABS(E).GT.A.OR.(E.EQ.A.AND.(2.*X).LT.Z).OR.
     1 (E.EQ.(-A).AND.Z.LT.0.)) GO TO 19
      GO TO 21
19    DO 20 I=1,3
      DO 20 J=1,3
      MT(I,J)=0
20    IF(I.EQ.J)MT(I,J)=1
      MT(3,1)=-(ISG(X)*ISG(E)*ISG(Z))
      IF((X*E*Z).EQ.0.0)MT(3,1)=-1
      IF(X.EQ.0.0.AND.E.EQ.0.0.AND.Z.NE.0.0)MT(3,1)=-ISG(Z)
      IF(X.EQ.0.0.AND.E.NE.0.0.AND.Z.EQ.0.0)MT(3,1)=-ISG(E)
      IF(X.NE.0.0.AND.E.EQ.0.0.AND.Z.EQ.0.0)MT(3,1)=-ISG(X)
      CALL MTP3(MT,AMT)
      C=A+C-E*ISG(E)
      X=X-Z*ISG(E)
      E=E-2.*A*ISG(E)
      GO TO 3
21    CONTINUE
      IF(ABS(Z).GT.A.OR.(Z.EQ.A.AND.(2.*X).LT.E).OR.
     1 (Z.EQ.(-A).AND.E.LT.0.)) GO TO 22
      GO TO 24
22    DO 23 I=1,3
      DO 23 J=1,3
      MT(I,J)=0
23    IF(I.EQ.J)MT(I,J)=1
      MT(2,1)=-(ISG(X)*ISG(E)*ISG(Z))
      IF((X*E*Z).EQ.0.0)MT(2,1)=-1
      IF(X.EQ.0.0.AND.E.EQ.0.0.AND.Z.NE.0.0)MT(2,1)=-ISG(Z)
      IF(X.EQ.0.0.AND.E.NE.0.0.AND.Z.EQ.0.0)MT(2,1)=-ISG(E)
      IF(X.NE.0.0.AND.E.EQ.0.0.AND.Z.EQ.0.0)MT(2,1)=-ISG(X)
      CALL MTP3(MT,AMT)
      B=A+B-Z*ISG(Z)
      X=X-E*ISG(Z)
      Z=Z-2.*A*ISG(Z)
      GO TO 3
24    DP=X+E+Z+A+B
      IF(DP.LT.0.0.OR.(DP.EQ.0.0.AND.(2.*(A+E)+Z).GT.0.0)) GO TO 25
      GO TO 27
25    C=A+B+C+X+E+Z
      X=2.*B+X+Z
      E=2.*A+E+Z
      DO 26 I=1,3
      DO 26 J=1,3
      MT(I,J)=0
26    IF(I.EQ.J)MT(I,J)=1
      MT(3,1)=1
      MT(3,2)=1
      CALL MTP3(MT,AMT)
      GO TO 3
27    ANIG(1)=A
      ANIG(2)=B
      ANIG(3)=C
      ANIG(4)=X/2.
      ANIG(5)=E/2.
      ANIG(6)=Z/2.
      DO 28 I=1,3
28    CN(I)=SQRT(ANIG(I))
      AN(1)=ANIG(4)/(CN(2)*CN(3))
      AN(2)=ANIG(5)/(CN(1)*CN(3))
      AN(3)=ANIG(6)/(CN(1)*CN(2))
      DO 30 I=1,3
      IF(ABS(AN(I)).LE.1E-6)GO TO 29
      AN(I)=ATAN2(SQRT(1.-AN(I)**2),AN(I))
      AN(I)=AN(I)*RD
      GO TO 30
29    AN(I)=90.
30    CONTINUE
      DO 99 I=1,3
      PARN(I)=CN(I)
      PARN(I+3)=AN(I)
99    CONTINUE
      RETURN
      END
      SUBROUTINE MTP3(M,AM)
      DIMENSION M(3,3),AM(3,3),AM1(3,3)
      DO 1 I=1,3
      DO 1 J=1,3
      AM1(I,J)=0.0
      DO 1 K=1,3
1     AM1(I,J)=AM1(I,J)+M(I,K)*AM(K,J)
      DO 2 I=1,3
      DO 2 J=1,3
2     AM(I,J)=AM1(I,J)
      RETURN
      END
      FUNCTION ISG(X)
      ISG=1
      IF(X.LT.0.0)ISG=-1
      RETURN
      END
